#include "m_usart88.h"


void uart_init(void)
{
	// set baud rate
	UBRR0H = (uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) >> 8);
	UBRR0L = (uint8_t) UART_BAUD_CALC(UART_BAUD_RATE,F_OSC);

	// Enable receiver and transmitter; enable RX interrupt
	UCSR0B = (1 << RXEN0) | (1 << TXEN0) | (1 << RXCIE0);

	//asynchronous 8N1
	UCSR0C = (1 << UCSZ00) | (1 << UCSZ01);
}


void uart_putc(unsigned char c)
{
	// wait until UDR ready
	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = c;    // send character
}


void uart_out8 (uint8_t value)
{
	uart_putc (0x30 +  value / 100);
	uart_putc (0x30 + (value % 100) / 10);
	uart_putc (0x30 +  value % 10);
}


void uart_out16 (uint16_t value)
{
	uart_putc (0x30 +  value / 10000);
	uart_putc (0x30 + (value % 10000) / 1000);
	uart_putc (0x30 + (value % 1000)  / 100);
	uart_putc (0x30 + (value % 100)   / 10);
	uart_putc (0x30 +  value % 10);   
}


// To be used in main program !!
// USART RX interrupt
//SIGNAL (SIG_UART_RECV)
//{
//}
