/************************************************************************/
/* RS - 232 PORT HEADER 												*/
/* 25.06.06 M. Kriegel													*/
/************************************************************************/

#ifndef __USART_88_H__
#define __USART_88_H__

// Includes
#include <avr/io.h>

// RS232 Settings
#define F_OSC 16000000		           /* oscillator-frequency in Hz */
#define UART_BAUD_RATE 9600
#define UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) ((F_OSC)/((UART_BAUD_RATE)*16l)-1)

// Functions

// Init RS - 232 PORT
void uart_init();

// Write character on RS - 232 PORT
void uart_putc(unsigned char c);

// Output 8bit value
void uart_out8 (uint8_t value);

// Output 16bit value
void uart_out16 (uint16_t value);


#endif
